;##################################################################
; NumBox
;##################################################################

#include NumBox.h

IDD_DLG1			equ		1000

DATA SECTION
	hInstance			HANDLE 		?
	hDlg				HANDLE		?

	ClassName			DB		"DialogClass",0

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControlsEx,esp,8,0x3FFF
	add esp,8
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke ExitProcess,0

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:%HANDLE

	// Define our main window class and register it
	mov		D[wc.cbSize], SIZEOF WNDCLASSEX
	mov		D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov		D[wc.lpfnWndProc], OFFSET DlgProc
	mov		D[wc.cbClsExtra], NULL
	mov		D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov		eax, [hInstance]
	mov		D[wc.hInstance], eax
	mov		D[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		D[wc.lpszMenuName], NULL
	mov		D[wc.lpszClassName], OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		D[wc.hIcon], eax
	mov		D[wc.hIconSm], eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		D[wc.hCursor], eax

	invoke	RegisterClassEx, offset wc
	or eax,eax
	jnz >
		// If we were unable to register the class shut down
		invoke	ExitProcess, -1
	:

	invoke	CreateDialogParam, [hInstance],IDD_DLG1, NULL, NULL, NULL
	or eax,eax
	jnz >
		// If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],eax

	invoke GetDlgItem,[hDlg], 1001

	// Subclass edit box
	Invoke SetWindowSubclass, eax, offset NumEditProc, 1, 0

	invoke ShowWindow,[hDlg],[nCmdShow]

	:
		invoke GetMessage, offset msg,NULL,0,0
		or eax,eax
		jz >
			invoke IsDialogMessage, [hDlg], offset msg
			or eax,eax
			jnz <
				invoke TranslateMessage, offset msg
				invoke DispatchMessage, offset msg
				jmp <
	:

	mov eax,[msg.wParam]

	ret
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		jmp >.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_DESTROY
		jmp >.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor eax,eax
	ret

ENDF

NumEditProc FRAME hwnd,uMsg,wParam,lParam,uIdSubclass,dwRefData
	LOCAL buffer[1024]:B
	LOCAL pt:POINT

	cmp D[uMsg],WM_CHAR
	jne >>.DISALLOWPASTE
		mov eax,[wParam]

		cmp eax,0x1F
		jle >>.PROCESSMESSAGE

		cmp eax,"-"
		je >.PROCESSSIGN

		cmp eax,"0"
		jl >
		cmp eax,"9"
		jle >>.PROCESSMESSAGE
		:
		xor eax,eax
		ret
		.PROCESSSIGN

		// If there is already a - sign then ignore
		invoke GetWindowText,[hwnd],offset buffer,256
		cmp B[buffer],"-"
		je <<

		invoke GetCaretPos,offset pt
		mov edx,[pt.x]
		mov eax,[pt.y]
		shl eax,16
		mov al,dl
		invoke SendMessage,[hwnd],EM_CHARFROMPOS,0,eax
		test eax,eax
		jnz <<

	.DISALLOWPASTE
	cmp D[uMsg],WM_PASTE
	jne >>.PROCESSMESSAGE
		// Get the data from the clipboard
		// It will always be in CF_TEXT format
		invoke OpenClipboard,[hwnd]
		invoke GetClipboardData,CF_TEXT
		// NULL return means no useable data
		test eax,eax
		jz >>.NOCLIPBOARD
		invoke lstrcpy,offset buffer,eax
		// Empty and close the clipboard
		invoke EmptyClipboard
		invoke CloseClipboard

		// Empty the edit control
		invoke SetWindowText,[hwnd],NULL

		// Attempt to translate the number
		invoke msvcrt.dll:atoi,offset buffer
		add esp,4

		invoke wsprintf,offset buffer,"%i",eax
		add esp,12
		invoke SetWindowText,[hwnd],offset buffer
		:
		xor eax,eax
		ret

		.NOCLIPBOARD
		invoke CloseClipboard
		xor eax,eax
		ret

	.PROCESSMESSAGE
	
	invoke DefSubclassProc, [hwnd], [uMsg], [wParam], [lParam]
	ret
endf
